library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity my_counter is

port( 
	CLK: in std_logic ;
	RST: in std_logic ;
	CNT_VAL: out std_logic_vector ( 3 downto 0 ) );
end;

architecture arch_my_counter of my_counter is

-- dclaration du signal interne = FF !!
-- signal CNT : std_logic_vector(2 downto 0); -- erreur, CNT, vecteur de 3 bits est affect
--  la sortie CNT_VAL qui contient 4 bits
signal CNT : std_logic_vector(3 downto 0); -- OK

begin

-- process du compteur (interne)
  process(CLK)
  begin
    if CLK'event and CLK='1' then
      if RST='1' then
        CNT <= "0000";
      else
        CNT <= CNT + 1;
      end if;
     end if; -- erreur si on oublie le "end if;"
  end process;

-- process de sortie
  process(CNT)
  begin
    CNT_VAL <= CNT;
    -- CNT <= CNT + 1; -- erreur, FF conduit par horloge et lui-mme (multiple drivers)
    -- RST <= '0';     -- erreur, c'est une entre, donc non-affectable
  end process;

end arch_my_counter;

